#ifndef DPA_PARSER_H
#define DPA_PARSER_H

#include <stddef.h>

enum category_change_state {
  CATEGORY_INACTIVE,
  CATEGORY_MATCHED,
  CATEGORY_ACTIVE
};

struct statics_context;
struct statics;
struct category {
  char* name;
  enum category_change_state(*updateCategory)(
    struct statics_context* context,
    struct statics*,
    int
  );
  size_t statics_size;
  size_t statics_align;
};

struct statics {
  unsigned count;
  enum category_change_state lastResult;
};

struct wordStatics {
  struct statics statics;
  unsigned currentWordLength;
};

struct sentenceStatics {
  struct statics statics;
  unsigned currentSentenceWordCount;
};

enum category_change_state updateCategoryCharacter(
  struct statics_context*,
  struct statics*,
  int
);

enum category_change_state updateCategoryNewline(
  struct statics_context*,
  struct statics*,
  int
);

enum category_change_state updateCategoryLetter(
  struct statics_context*,
  struct statics*,
  int
);

enum category_change_state updateCategoryWord(
  struct statics_context*,
  struct statics*,
  int
);

enum category_change_state updateCategorySentence(
  struct statics_context*,
  struct statics*,
  int
);

extern const struct category categories[];

enum category_index {
  CATEGORY_CHARACTER,
  CATEGORY_NEWLINE,
  CATEGORY_LETTER,
  CATEGORY_WORD,
  CATEGORY_SENTENCE,
  
  CATEGORY_COUNT // must be the last member
};

struct staticsResult {
  struct statics statics[CATEGORY_COUNT];
};

struct statics_context {
  struct statics* statics[CATEGORY_COUNT];
};

void defaultStaticsCalculator( struct statics_context*, void* );
struct staticsResult callWithStaticsContext( void(*)( struct statics_context*, void* ), void* );

#endif